/***********************
 * Capteur piezoelectrique
 * Sketch compatible 2 Ana et ZIP
 **********************/

// Importer la possibilite du Midi
import rwmidi.*;
// RWMidi se trouve chez http://ruinwesen.com/blog?id=95
MidiInput input;

// Variables pour le traitement du capteur
// Variables for sensor analysis
int maxpiezo = 0;
int[] registrepiezo = new int[2];
int sens = 1;
int sensdavant = 1;
int affiche = 0;

// Reception des capteurs analogiques
// Receiving data sensor
int[] valeur = new int[4];
int numero;

// Reception des donnees et traitement
void controllerChangeReceived(Controller ctlchg) {
  numero = ctlchg.getCC();
  if ((numero<4)&&(numero>=0)) {
    valeur[numero] = ctlchg.getValue();
    println("Capteur n°" + (numero+1) + " " + valeur[numero]);

    // Memorisation de la valeur precedente
    registrepiezo[1]=registrepiezo[0];
    registrepiezo[0]=valeur[1];

    // Sens d'evolution des donnees (pics)
    // memorisation du sens prededent
    sensdavant = sens;
    sens = registrepiezo[0] - registrepiezo[1];
    // simplifier les valeurs possibles de sens
    if (sens > 0) {
    sens = 1;
    }
    else {
    sens = 0;
    }
    // Pic
    if ((sensdavant == 1) && (sens == 0)) {
          affiche = 1;
    maxpiezo = registrepiezo[1];
    println("Maximum "+maxpiezo);
    }
  }
}

void setup() {
  size(500,500);
  background(0);
  // Affichage des peripheriques Midi disponibles sur l'ordinateur
  // Display avalaible Midi devices
  println("........Peripheriques Midi In........");
  println(RWMidi.getInputDevices());
  // Choisir le numero du peripherique, ici [0], dans la liste
  // Choose the Midi device where is the sensor
  input = RWMidi.getInputDevices()[0].createInput(this);
}

void draw() {
  // Attenuation
  // Fading
  fill(0,10);
  rect(0,0, width, height);
  
  // Dessiner un cercle seulement si le capteur atteint un pic
  // Draw a circle only if the sensor reaches a peak
if (affiche == 1) {
    fill(240, 210, 30);
    // La taille depend de l'impact detecte
    // Size depends on detected impact
    ellipse(width*0.5, height*0.5, maxpiezo*2, maxpiezo*2);
        affiche = 0;
}
}
